
#!/bin/sh

prg=$1

if [ -z $1 ]; then
	echo "argument prg not supplied!"
	echo "Usage: ./build.sh <prg>"
	echo "e.g. ./build.sh hello      <-- don't mention extention .c"
	echo "exiting ..."
	echo "------------------------------------------------------------------------"
	exit -1
fi

echo "building $1 using clang ..."
clang "$1".c -o $1
echo "running $1 executable ..."
./$1
echo "------------------------------------------------------------------------"

echo "compile the C file into a LLVM bitcode file ..."
clang -O3 -emit-llvm "$1".c -c -o "$1".bc
echo "running $1 from bitcode ..."
lli "$1".bc
echo "------------------------------------------------------------------------"
echo "displaying llvm assembly code ..."
llvm-dis < "$1".bc
echo "------------------------------------------------------------------------"

echo "Compile the program to native assembly using the LLC code generator ..."
llc "$1".bc -o "$1".s

echo "Assemble the native assembly language file into a program ..."
gcc "$1".s -o "$1".native

echo "Execute the native code program ..."
./"$1".native
echo "------------------------------------------------------------------------"

